﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MBegin();

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MAddFiles(int id,string infile);

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MConvert(int id,string infile,string outfile);

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MConvertAll(int id,string outfile);

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncrypt(int id, string userpassword, string ownerpassword,int encryptlevel, int printing, int copying, int changing, int adding);
        
        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MInformation(int id, string title, string subject, string author,string keywords, string creator, string producer);

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MWatermark(int id, string text, int fsize, int fcolor, int position, int angle, int xoff, int yoff, int background);

        [DllImport("pstopdf", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEnd(int id);


        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int id = MBegin();    
            if(id>0)
            {
                int level = 40;
                int printing = 1;
                int copying = 1;
                int changing = 0;
                int adding = 0;
                //Set PDF Encrypt
                MEncrypt(id, "password", "password2", level, printing, copying, changing, adding);

                //Add files
                MAddFiles(id, "test.ps");
                MAddFiles(id, "test2.ps");

                //Combine all files into one pdf file
                MConvertAll(id, "combine.pdf");
                MEnd(id);

	            MEnd(id);
	        }	
	        MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int id = MBegin();
            if (id > 0)
            {
                //Set PDF Information
                MInformation(id, "title", "subject", "author", "keywords", "creator", "producer");

                MConvert(id, "test.ps", "test.pdf");
                MEnd(id);
            }

            id = MBegin();
            if (id > 0)
            {
                int fsize = 16;
                int fcolor = 255;//red
                int position = 2;//Top-Center
                int angle = 0;
                int xoff = 0;
                int yoff = 0;
                int background = 1;
                //Stamping
                MWatermark(id, "Watermark", fsize, fcolor, position, angle, xoff, yoff, background);

                MConvert(id, "test2.ps", "test2.pdf");
                MEnd(id);
            }
            MessageBox.Show("Convert finished!");
        }
    }
}
