//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadPsToPdfDll()
{
	m_hinstLib = LoadLibrary("pstopdf.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMAddFiles = (MAddFiles *)GetProcAddress(m_hinstLib, "MAddFiles");
	if( pMAddFiles == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMConvertAll = (MConvertAll *)GetProcAddress(m_hinstLib, "MConvertAll");
	if( pMConvertAll == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMEncrypt = (MEncrypt *)GetProcAddress(m_hinstLib, "MEncrypt");
	if( pMEncrypt == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreePsToPdfDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreePsToPdfDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadPsToPdfDll() == FALSE ){
		ShowMessage("Load pstopdf.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		long adding = 0;
		//Set PDF Encrypt
		pMEncrypt(id,"password","password2",level,printing,copying,changing,adding);
		
		//Add files
		pMAddFiles(id,"test.ps");
		pMAddFiles(id,"test2.ps");

		//Combine all files into one pdf file
		pMConvertAll(id,"combine.pdf");
		pMEnd(id);
	}	

	FreePsToPdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadPsToPdfDll() == FALSE ){
		ShowMessage("Load pstopdf.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");
		
		pMConvert(id,"test.ps","test.pdf");
		pMEnd(id);
	}

	id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
        long background=1;
		//Stamping
		pMWatermark(id,"Watermark",fsize,fcolor,position,angle,xoff,yoff,background);

		pMConvert(id,"test2.ps","test2.pdf");
		pMEnd(id);
	}

	FreePsToPdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
